#include <inttypes.h>
#include <avr/io.h>
#include <avr/interrupt.h>
#include <util/delay.h>
#include <string.h>
#include "main.h"
#include "keycodes.h"
#include <avr/pgmspace.h>
volatile uint8_t stat=0,sel=0,osel=0,tmp[4],commit=0,cmenu=1;
void* colors[15];
void colorlist_i(void);
void inittty(void)
	{
	sendstring_P(PSTR("\033[2J\033[H"));
	sendstring_P(PSTR("LightController 0.4.2\n\r"));
	sendstring_P(PSTR("Ready. Press any key to init UI.\n\r"));
	sendstring_P(PSTR("\033&j@"));
	colors[0]=PSTR("Open/White");
	colors[1]=PSTR("Red");
	colors[2]=PSTR("Yellow");
	colors[3]=PSTR("Purple");
	colors[4]=PSTR("Green");
	colors[5]=PSTR("Orange 1");
	colors[6]=PSTR("Blue");
	colors[7]=PSTR("Pink");
	colors[8]=PSTR("Light green");
	colors[9]=PSTR("Light blue");
	colors[10]=PSTR("Orange 2");
	colors[11]=PSTR("Light yellow");
	colors[12]=PSTR("Magent");
	colors[13]=PSTR("Red/Blue");
	colors[14]=PSTR("Yellow/Green");
}

void locate(uint8_t y, uint8_t x)
	{
	sendstring("\033\033[");
	sendu8_d(y);
	sendchar(';');
	sendu8_d(x);
	sendchar('H');
}

void box(uint8_t x, uint8_t y, uint8_t w, uint8_t h)
	{
	locate(y,x);
	sendchar('+');
	for(uint8_t i=0;i<w-2;i++)
		sendchar('-');
	sendchar('+');
	if (h>2)
		for(uint8_t j=1; j<h-1; j++)
			{
			locate(y+j,x);
			sendchar('|');
			for(uint8_t i=0;i<w-2;i++)
				sendchar(' ');
			sendchar('|');
		}
	if (h>1)
		{
		locate(y+h-1,x);
		sendchar('+');
		for(uint8_t i=0;i<w-2;i++)
			sendchar('-');
		sendchar('+');
	}
}
void clear(void)
	{
	sendstring("\033[2J");
}
void mainmenu_i(void)
	{
	sendstring_P(PSTR("\033[2J"));
	box(21,9,40,7);
	locate(9,23);
	sendstring_P(PSTR("[Main Menu]"));
	locate(10,24);
	sendstring_P(PSTR("\033[1mM\033[0movement setup"));
	locate(11,24);
	sendstring_P(PSTR("\033[1mC\033[0molor menu"));
	locate(12,24);
	sendstring_P(PSTR("\033[1mP\033[0mresets"));
	locate(13,24);
	sendstring_P(PSTR("\033[1mC\033[0mhasers"));
	locate(14,24);
	sendstring_P(PSTR("S\033[1mu\033[0mbmaster"));
	locate (10,23);
	sendchar('>');
}
void mainmenu_u(uint8_t sel,uint8_t osel)
	{
	locate (10+osel,23);
	sendchar(' ');
	locate (10+sel,23);
	sendchar('>');
}
void initmenu(void)
	{
	stat=0;
	sel=0;
	osel=0;
	commit=0;
	tmp[0]=tmp[1]=tmp[2]=tmp[3]=0;
}
void menu(uint16_t keyb)
	{
	commit=0;
	switch(stat)
		{
		case 0:
			sel=0;
			switch (cmenu)
			{
			case 0:
			mainmenu_i();
			break;
			case 1:
			colorlist_i();
			break;
		}
			stat=1;
			break;
		case 1:
			if (keyb==0)
					break;
			switch(keyb)
				{
				case KB_UP:
					sel--;
					break;
				case KB_DOWN:
					sel++;
					break;
				case KB_ESC:
					stat=0;
					pushkey(0x00);
					break;
				case KB_ENTER:
					commit=1;
					
					break;
				case 'S': case 's':
					sel=0;
					commit=1;
					break;
				case 'M': case 'm':
					sel=1;
					commit=1;
					break;
				case 'P': case 'p':
					sel=2;
					commit=1;
					break;
				case 'C': case 'c':
					sel=3;
					commit=1;
					break;
				case 'U': case 'u':
					sel=4;
					commit=1;
					break;
			}
			if (sel==5)
				sel=0;
			if (sel==255)
				sel=4;
			mainmenu_u(sel,osel);
			break;
	}
	osel=sel;
}

void colorlist_i(void)
 {
 sendstring_P(PSTR("\033[2J"));
	box(5,3,20,17);
	locate(3,7);
	sendstring_P(PSTR("[Color wheel]"));
	for (uint8_t c=0;c<15;c++)
		{
		locate(4+c,7);
		sendstring_P(colors[c]);
	}
	box(31,3,20,17);
	locate(3,33);
	sendstring_P(PSTR("[Gobo wheel]"));
	locate(4,33);
	sendstring_P(PSTR("Open"));
	for (uint8_t g=1;g<15;g++)
		{
		locate(4+g,33);
		sendstring_P(PSTR("Gobo "));
		if (g>9)
			sendchar(0x30+g/10);
		sendchar(0x30+g%10);
	}
	box(57,3,20,8);
	locate(3,59);
	sendstring_P(PSTR("[Shutter]"));
	locate(4,59);
	sendstring_P(PSTR("Closed"));
	locate(5,59);
	sendstring_P(PSTR("Open"));
	locate(6,59);
	sendstring_P(PSTR("Strobe (slow)"));
	locate(7,59);
	sendstring_P(PSTR("Strobe (med)"));
	locate(8,59);
	sendstring_P(PSTR("Strobe (fast)"));
	locate(9,59);
	sendstring_P(PSTR("Strobe on beat"));
	
	box(57,12,20,8);
	locate(12,59);
	sendstring_P(PSTR("[Movement]"));
	locate(13,59);
	sendstring_P(PSTR("Center (static)"));
	locate(14,59);
	sendstring_P(PSTR("Stage (static)"));
	locate(15,59);
	sendstring_P(PSTR("Circular (sync)"));
	locate(16,59);
	sendstring_P(PSTR("Circular (async)"));
	locate(17,59);
	sendstring_P(PSTR("Lissajous (async)"));
	locate(18,59);
	sendstring_P(PSTR("FFT based (????)"));
	
	locate(1,28);
	sendstring_P(PSTR("ScanControl for Eurolite TS-150"));
	
	box(5,20,20,5);
	locate(20,7);
	sendstring_P(PSTR("[Color change]"));
	locate(21,7);
	sendstring_P(PSTR("Manual"));
	locate(22,7);
	sendstring_P(PSTR("Beat, loop + sync"));
	locate(23,7);
	sendstring_P(PSTR("Beat, rnd + async"));
	
	box(31,20,20,5);
	locate(20,33);
	sendstring_P(PSTR("[Gobo change]"));
	locate(21,33);
	sendstring_P(PSTR("Manual"));
	locate(22,33);
	sendstring_P(PSTR("Beat, loop + sync"));
	locate(23,33);
	sendstring_P(PSTR("Beat, rnd + async"));
	
	box(57,21,20,4);
	locate(21,59);
	sendstring_P(PSTR("[Setup]"));
	locate(22,59);
	sendstring_P(PSTR("Prog. values"));
	locate(23,59);
	sendstring_P(PSTR("Prog. params"));
}
/*
clear();
					locate(1, 1);
					sendstring("\033[7m");
					for(uint8_t i=0;i<80;i++)
						sendchar(' ');
					locate(1, 2);
					sendstring("Moving lights setup");
					locate(3, 1);
					sendstring("\033[0m");
					locate(25, 1);
					sendstring("[\033[7mN\033[0m]ew device   /\\ \\/ Select Line   < > Select Field   LN /\\ LN\\/ Change value");
					locate(2,1);
*/
