
//Einstellungen BREAK-Dauer (min 88s, 125s empfohlen)
#define BRK_TCNT 0
#define BRK_PSCB 1

//EInstellungen MAB-Dauer (min 8s, max 1s)
#define MAB_TCNT 0
#define MAB_PSCB 1

//Anzahl DMX-Kanle
#define DMX_CHAC 50 

volatile uint8_t dmx_data[DMX_CHAC];
volatile uint8_t dmx_ptr=0;
volatile uint8_t dmx_tmrfunc=0;

SIGNAL(SIG_OVERFLOW0)
	{
	if (dmx_tmrfunc==0) //BREAK Ende, MAB start
		{
		TCCR0=TCCR0&0xf8|MAB_PSCB;
		TCNT0=MAB_TCNT;
		dmx_tmrfunc=1;
		PORTD|=(1<<1)//TxD High
	}else //MAB Ende
		{
		dmx_ptr=0;
		UCSRB|=(1<<TXEN)|(1<<UDRIE);//USART wieder anschalten
	}
}
SIGNAL(SIG_UART_DATA)
	{
	UDR=dmx_data[dmx_ptr++];
	if (dmx_ptr==DMX_CHAC)
		{
		UCSRB&=~(1<<UDRIE); //UDR Empty ISR deaktivieren
		UCSRB|=(1<<TXCIE);	//Tx Complete ISR aktivieren
		PORTD&=~(1<<1); //TxD Low (wird bernommen, sobald USART fertig ist)
	}
}
SIGNAL(SIG_UART_TRANS)
	{
	UCSRB|=~((1<<TXEN)|(1<<UDRIE));//USART ausschalten
	TCCR0=TCCR0&0xf8|BRK_PSCB;
	TCNT0=BRK_TCNT;
	dmx_tmrfunc=0; //BREAK wird erzeugt
	UCSRB&=~(1<<TXCIE);
}